## faudio 19.07

=== CMakeLists.txt ===
# CMake Project for FAudio
# Written by @NeroBurner
cmake_minimum_required(VERSION 2.8.12)
project(FAudio)

# Options
option(FFMPEG "Enable FFmpeg support (WMA, XMA)" OFF)
option(BUILD_UTILS "Build utils/ folder" OFF)
option(BUILD_TESTS "Build tests/ folder for unit tests to be executed on the host against FAudio" OFF)
if(WIN32)
option(BUILD_CPP "Build cpp/ folder (COM wrapper for XAudio2)" OFF)
endif()
option(XNASONG "Build with XNA_Song.c" ON)
option(LOG_ASSERTIONS "Bind FAudio_assert to log, instead of platform's assert" OFF)
option(FORCE_ENABLE_DEBUGCONFIGURATION "Enable DebugConfiguration in all build types" OFF)
if(WIN32)
option(INSTALL_MINGW_DEPENDENCIES "Add dependent libraries to MinGW install target" OFF)
endif()

# C99 Requirement
if(${CMAKE_VERSION} VERSION_LESS "3.1.3")
	message(WARNING "Your CMake version is too old, set -std=c99 yourself!")
else()
	set(CMAKE_C_STANDARD 99)
	set(CMAKE_C_EXTENSIONS OFF)
endif()

# Version
SET(LIB_MAJOR_VERSION "0")
SET(LIB_MINOR_VERSION "19")
SET(LIB_REVISION "07")
SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")

# Build Type
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	# By default, we use Release
	message(STATUS "Setting build type to 'Release' as none was specified.")
	set(CMAKE_BUILD_TYPE "Release" CACHE
		STRING "Choose the type of build." FORCE
	)

	# Set the possible values of build type for cmake-gui
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY
		STRINGS "Debug" "Release" "RelWithDebInfo"
	)
endif()

# Add our repository's module path to CMake's module path list
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# Platform Flags
if(APPLE)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.7)
elseif(WIN32)
	# "FAudio.dll", not "libFAudio.dll"
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

# Helper function for finding/installing MinGW libs
if(INSTALL_MINGW_DEPENDENCIES)
	include(cmake/install_shared_libs.cmake)
endif()

# Source lists
add_library(FAudio SHARED
	# Public Headers
	include/F3DAudio.h
	include/FACT3D.h
	include/FACT.h
	include/FAPOBase.h
	include/FAPOFX.h
	include/FAPO.h
	include/FAudioFX.h
	include/FAudio.h
	# Internal Headers
	src/FACT_internal.h
	src/FAudio_internal.h
	src/stb.h
	src/stb_vorbis.h
	# Source Files
	src/F3DAudio.c
	src/FACT3D.c
	src/FACT.c
	src/FACT_internal.c
	src/FAPOBase.c
	src/FAPOFX.c
	src/FAPOFX_echo.c
	src/FAPOFX_eq.c
	src/FAPOFX_masteringlimiter.c
	src/FAPOFX_reverb.c
	src/FAudio.c
	src/FAudioFX_reverb.c
	src/FAudioFX_volumemeter.c
	src/FAudio_internal.c
	src/FAudio_internal_simd.c
	src/FAudio_operationset.c
	src/FAudio_platform_sdl2.c
	# Optional source files
	src/XNA_Song.c
	src/FAudio_ffmpeg.c
)

# Only disable DebugConfiguration in release builds
if(NOT FORCE_ENABLE_DEBUGCONFIGURATION)
	target_compile_definitions(FAudio PRIVATE $<$<CONFIG:Release>:FAUDIO_DISABLE_DEBUGCONFIGURATION>)
endif()

# FAudio_assert Customization
if(LOG_ASSERTIONS)
	target_compile_definitions(FAudio PUBLIC FAUDIO_LOG_ASSERTIONS)
endif()

# FAudio folders as includes, for other targets to consume
target_include_directories(FAudio PUBLIC
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
)

# MinGW builds should statically link libgcc
if(MINGW)
	target_link_libraries(FAudio PRIVATE -static-libgcc)
endif()

# Soname
set_target_properties(FAudio PROPERTIES OUTPUT_NAME "FAudio"
	VERSION ${LIB_VERSION}
	SOVERSION ${LIB_MAJOR_VERSION}
)

# XNA_Song Support
if(NOT XNASONG)
	target_compile_definitions(FAudio PRIVATE DISABLE_XNASONG)
endif()

# FFmpeg Support
if(FFMPEG)
	# Add the extra definition...
	target_compile_definitions(FAudio PRIVATE HAVE_FFMPEG=1)

	# Find FFmpeg...
	find_package(FFmpeg COMPONENTS
		avcodec
		avutil # dep of avcodec
		swresample # dep of avcodec
		REQUIRED
	)

	# Include/Link FFmpeg...
	target_include_directories(FAudio PRIVATE ${FFmpeg_INCLUDE_DIRS})
	target_link_libraries(FAudio PRIVATE ${FFmpeg_LIBRARIES})

	# Install FFmpeg for MinGW target
	if(INSTALL_MINGW_DEPENDENCIES)
		install_shared_libs(bin ${FFmpeg_LIBRARIES})
	endif()
endif(FFMPEG)

# SDL2 Dependency
if (NOT DEFINED SDL2_INCLUDE_DIRS AND NOT DEFINED SDL2_LIBRARIES)
	find_package(SDL2 CONFIG)
endif()
if (TARGET SDL2::SDL2)
	message(STATUS "using TARGET SDL2::SDL2")
	target_link_libraries(FAudio PUBLIC SDL2::SDL2)
	if(INSTALL_MINGW_DEPENDENCIES)
		install_shared_libs(bin SDL2::SDL2)
	endif()
elseif (TARGET SDL2)
	message(STATUS "using TARGET SDL2")
	target_link_libraries(FAudio PUBLIC SDL2)
	if(INSTALL_MINGW_DEPENDENCIES)
		install_shared_libs(bin SDL2)
	endif()
else()
	message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
	target_include_directories(FAudio PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
	target_link_libraries(FAudio PUBLIC ${SDL2_LIBRARIES})
	if(INSTALL_MINGW_DEPENDENCIES)
		install_shared_libs(bin ${SDL2_LIBRARIES})
	endif()
endif()

# utils/ Folder
if(BUILD_UTILS)
	# Shared ImGui Framework
	add_library(uicommon STATIC
		utils/uicommon/FAudioUI_main.cpp
		utils/uicommon/FAudioUI_ui.cpp
		utils/uicommon/glfuncs.h
		utils/uicommon/glmacros.h
		utils/uicommon/imconfig.h
		utils/uicommon/imgui.cpp
		utils/uicommon/imgui_demo.cpp
		utils/uicommon/imgui_draw.cpp
		utils/uicommon/imgui.h
		utils/uicommon/imgui_internal.h
		utils/uicommon/stb_rect_pack.h
		utils/uicommon/stb_textedit.h
		utils/uicommon/stb_truetype.h
	)
	target_link_libraries(uicommon PUBLIC FAudio)

	# Shared WAV Resources
	add_library(wavs STATIC utils/wavcommon/wavs.cpp)
	target_compile_definitions(wavs PUBLIC
		RESOURCE_PATH="${CMAKE_SOURCE_DIR}/utils/wavcommon/resources"
	)

	# These tools do NOT use uicommon
	add_executable(testparse utils/testparse/testparse.c)
	target_link_libraries(testparse PRIVATE FAudio)
	add_executable(testxwma utils/testxwma/testxwma.cpp)
	target_link_libraries(testxwma PRIVATE FAudio)

	# These tools use uicommon, but NOT wavs
	add_executable(facttool utils/facttool/facttool.cpp)
	target_link_libraries(facttool PRIVATE uicommon)
	add_executable(testfilter
		utils/testfilter/audio.cpp
		utils/testfilter/audio_faudio.cpp
		utils/testfilter/audio.h
		utils/testfilter/audio_player.h
		utils/testfilter/audio_xaudio.cpp
		utils/testfilter/oscillator.cpp
		utils/testfilter/oscillator.h
		utils/testfilter/testfilter.cpp
	)
	target_link_libraries(testfilter PRIVATE uicommon)

	# These tools use both uicommon and wavs
	add_executable(testreverb
		utils/testreverb/audio.cpp
		utils/testreverb/audio_faudio.cpp
		utils/testreverb/audio.h
		utils/testreverb/audio_xaudio.cpp
		utils/testreverb/testreverb.cpp
	)
	target_link_libraries(testreverb PRIVATE uicommon wavs)
	add_executable(testvolumemeter
		utils/testvolumemeter/audio.cpp
		utils/testvolumemeter/audio_faudio.cpp
		utils/testvolumemeter/audio.h
		utils/testvolumemeter/testvolumemeter.cpp
	)
	target_link_libraries(testvolumemeter PRIVATE uicommon wavs)
endif()

# define install directories
# on mingw-w64 cross compilation $CMAKE_INSTALL_LIBDIR is set to an absolute
# path. Work around that by hard coding the directories on windows
if(WIN32)
	set(FAudio_INSTALL_INCLUDEDIR include)
	set(FAudio_INSTALL_BINDIR bin)
	set(FAudio_INSTALL_LIBDIR lib)
else()
	include(GNUInstallDirs)
	set(FAudio_INSTALL_INCLUDEDIR ${CMAKE_INSTALL_INCLUDEDIR})
	set(FAudio_INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
	set(FAudio_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
endif()

# cpp/ Folder
if(BUILD_CPP)
	# XAPOBase, used by XAudio2 and XAPOFX
	add_library(XAPOBase STATIC
		cpp/XAPOBase.cpp
	)
	target_compile_definitions(XAPOBase PRIVATE
		FAUDIOCPP_EXPORTS
		_WIN32_WINNT=0x0600
	)
	target_link_libraries(XAPOBase PRIVATE FAudio)
	if(MINGW)
		target_link_libraries(XAPOBase PRIVATE
			"-Wl,--enable-stdcall-fixup"
		)
		# Enable various compiler warnings
		target_link_libraries(XAPOBase PRIVATE
			-Wall -pedantic
			-Wsign-compare
			-Wshadow
		)
	endif()

	# We're about to make a whole bunch of DLLs...
	set(FAudio_CPP_libs "")

	# XAudio2 2.0-2.7
	foreach(lib_version RANGE 0 7)
		set(faudio_cpp_target "xaudio2_${lib_version}")
		add_library(${faudio_cpp_target} SHARED
			cpp/com_utils.cpp
			cpp/xaudio2.cpp
			cpp/XAudio2fx.cpp
			cpp/win_registry.cpp
		)
		target_compile_definitions(${faudio_cpp_target} PRIVATE
			"XAUDIO2_VERSION=${lib_version}"
		)
		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase)
		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
	endforeach()

	# XAudio2 2.8-2.9
	foreach(lib_version RANGE 8 9)
		set(faudio_cpp_target "xaudio2_${lib_version}")
		add_library(${faudio_cpp_target} SHARED
			cpp/com_utils.cpp
			cpp/xaudio2.cpp
			cpp/XAudio2fx.cpp
			cpp/win_device.cpp
			cpp/X3DAudio.cpp
			cpp/XAPOFX.cpp
		)
		target_compile_definitions(${faudio_cpp_target} PRIVATE
			"XAUDIO2_VERSION=${lib_version}"
			UNICODE
		)
		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase setupapi)
		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
	endforeach()

	# X3DAudio 1.3-1.7
	foreach(lib_version RANGE 3 7)
		set(faudio_cpp_target "x3daudio1_${lib_version}")
		add_library(${faudio_cpp_target} SHARED cpp/X3DAudio.cpp)
		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
	endforeach()

	# XAPOFX 1.1-1.5
	foreach(lib_version RANGE 1 5)
		set(faudio_cpp_target "xapofx1_${lib_version}")
		add_library(${faudio_cpp_target} SHARED
			cpp/com_utils_xapofx.cpp
			cpp/XAPOFX.cpp
		)
		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase)
		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
	endforeach()

	# XACTEngine3 3.0-3.7
	foreach(lib_version RANGE 0 7)
		set(faudio_cpp_target "xactengine3_${lib_version}")
		add_library(${faudio_cpp_target} SHARED
			cpp/com_utils_xact.cpp
			cpp/xact3.cpp
			cpp/win_registry.cpp
		)
		target_compile_definitions(${faudio_cpp_target} PRIVATE
			"XACT3_VERSION=${lib_version}"
		)
		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
	endforeach()

	# Common Libraries/Definitions
	foreach(faudio_cpp_target ${FAudio_CPP_libs})
		target_link_libraries(${faudio_cpp_target} PRIVATE
			ole32
			FAudio
		)
		target_compile_definitions(${faudio_cpp_target} PRIVATE
			FAUDIOCPP_EXPORTS
			_WIN32_WINNT=0x0600
		)

		# MinGW builds should statically link libgcc/libstdc++
		if(MINGW)
			target_link_libraries(${faudio_cpp_target} PRIVATE
				"-Wl,--enable-stdcall-fixup"
				"-static-libgcc -static-libstdc++"
			)
			# Enable various compiler warnings
			target_link_libraries(${faudio_cpp_target} PRIVATE
				-Wall -pedantic
				-Wsign-compare
				-Wshadow
			)
		endif()
	endforeach()

	# Add libraries to install target
	install(TARGETS ${FAudio_CPP_libs}
		RUNTIME DESTINATION ${FAudio_INSTALL_BINDIR}
		LIBRARY DESTINATION ${FAudio_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${FAudio_INSTALL_LIBDIR}
	)
	# Add Wine install script to install target
	install(PROGRAMS cpp/scripts/wine_setup_native
		DESTINATION ${FAudio_INSTALL_BINDIR}
	)
	# Install runtime dependencies
	if(INSTALL_MINGW_DEPENDENCIES)
		install_shared_libs(bin -lwinpthread-1 -lwinpthread -lSDL2 -liconv)
	endif()
endif()

# tests/ Folder
if(BUILD_TESTS)
	add_executable(faudio_tests tests/xaudio2.c)
	target_link_libraries(faudio_tests PRIVATE FAudio)
endif()

# Installation

# Public Headers...
install(
	DIRECTORY include/
	DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
)
# Libraries...
install(
	TARGETS ${PROJECT_NAME}
	EXPORT ${PROJECT_NAME}-targets
	INCLUDES DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
	RUNTIME DESTINATION ${FAudio_INSTALL_BINDIR}
	LIBRARY DESTINATION ${FAudio_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${FAudio_INSTALL_LIBDIR}
)

# Generate cmake-config file, install CMake files
include(CMakePackageConfigHelpers)
configure_package_config_file(
	cmake/config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
install(
	FILES ${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}-config.cmake
	DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
install(
	EXPORT ${PROJECT_NAME}-targets

=== csharp/Makefile ===
# Makefile for FAudio#
# Written by Ethan "flibitijibibo" Lee

build: clean
	mkdir bin
	cp FAudio-CS.dll.config bin
	mcs /unsafe -debug -out:bin/FAudio-CS.dll -target:library FAudio.cs

clean:
	rm -rf bin

=== debian/changelog ===
faudio (19.07-1) unstable; urgency=medium

  * New upstream release
  * Build with large file support.
  * Update standards version to 4.4.0.
  * Specify Build-Depends-Package in the symbols file.

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 17 Jul 2019 00:52:33 +0000

faudio (19.06.07-3) unstable; urgency=medium

  * Fix autopkgtest regression introduced by the previous upload.

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 12 Jul 2019 00:57:39 +0000

faudio (19.06.07-2) unstable; urgency=medium

  * Update standards version to 4.4.0.
  * Install tests to multiarch directories (closes: #930466).

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 09 Jun 2019 04:35:04 +0000

faudio (19.06.07-1) unstable; urgency=medium

  * New upstream release.
  * Enable support for the xWMA codec.
  * Build tests and add them to autopkgtest.
  * Fix name of the shared object (closes: #927451).
  * Add cmake to the build dependencies (closes: #926825).
  * List files from Sean Barrett in debian/copyright (closes: #926578).

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 09 Jun 2019 00:49:52 +0000

faudio (19.02-1) unstable; urgency=medium

  * Initial release.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Feb 2019 20:53:57 -0500

=== debian/control ===
Source: faudio
Section: libs
Priority: optional
Uploaders: Michael Gilbert <mgilbert@debian.org>
Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
Build-Depends:
 cmake,
 libstb-dev,
 libsdl2-dev,
 libavformat-dev,
 debhelper (>= 11),
Standards-Version: 4.4.0
Rules-Requires-Root: no
Homepage: https://github.com/FNA-XNA/FAudio

Package: libfaudio0
Multi-Arch: same
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: XAudio sound processing reimplementation - library
 FAudio is a sound processing library that aims to support fully accurate
 DirectX audio capabilities including XAudio2, X3DAudio, XAPO, and XACT3.
 .
 This package provides the library itself.

Package: libfaudio-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfaudio0 (= ${binary:Version}),
Description: XAudio sound processing reimplementation - development files
 FAudio is a sound processing library that aims to support fully accurate
 DirectX audio capabilities including XAudio2, X3DAudio, XAPO, and XACT3.
 .
 This package provides the development files.

=== debian/rules ===
#!/usr/bin/make -f

# output verbose build commands
export DH_VERBOSE=1

# allow ./debian/rules binary to be executed without root
export DEB_RULES_REQUIRES_ROOT=no

# enable all build hardening flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all future=+lfs

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --no-warn-unused-cli -DFFMPEG=ON -DBUILD_TESTS=ON

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/FNA-XNA/FAudio/tags .*/v?(\d\S+)\.tar\.gz

## faudio 19.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 # Version
 SET(LIB_MAJOR_VERSION "0")
 SET(LIB_MINOR_VERSION "19")
-SET(LIB_REVISION "07")
+SET(LIB_REVISION "12")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type
@@ -151,32 +151,40 @@
 
 	# Install FFmpeg for MinGW target
 	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(bin ${FFmpeg_LIBRARIES})
+		install_shared_libs(FILES ${FFmpeg_LIBRARIES} DESTINATION bin NO_INSTALL_SYMLINKS REQUIRED)
 	endif()
 endif(FFMPEG)
 
 # SDL2 Dependency
-if (NOT DEFINED SDL2_INCLUDE_DIRS AND NOT DEFINED SDL2_LIBRARIES)
-	find_package(SDL2 CONFIG)
-endif()
-if (TARGET SDL2::SDL2)
-	message(STATUS "using TARGET SDL2::SDL2")
-	target_link_libraries(FAudio PUBLIC SDL2::SDL2)
-	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(bin SDL2::SDL2)
-	endif()
-elseif (TARGET SDL2)
-	message(STATUS "using TARGET SDL2")
-	target_link_libraries(FAudio PUBLIC SDL2)
-	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(bin SDL2)
-	endif()
-else()
-	message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
+if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
+	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
 	target_include_directories(FAudio PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
 	target_link_libraries(FAudio PUBLIC ${SDL2_LIBRARIES})
 	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(bin ${SDL2_LIBRARIES})
+		install_shared_libs(${SDL2_LIBRARIES} DESTINATION bin NO_INSTALL_SYMLINKS)
+	endif()
+else()
+	# Only try to autodetect if both SDL2 variables aren't explicitly set
+	find_package(SDL2 CONFIG)
+	if (TARGET SDL2::SDL2)
+		message(STATUS "using TARGET SDL2::SDL2")
+		target_link_libraries(FAudio PUBLIC SDL2::SDL2)
+		if(INSTALL_MINGW_DEPENDENCIES)
+			install_shared_libs(TARGETS SDL2::SDL2 DESTINATION bin NO_INSTALL_SYMLINKS REQUIRED)
+		endif()
+	elseif (TARGET SDL2)
+		message(STATUS "using TARGET SDL2")
+		target_link_libraries(FAudio PUBLIC SDL2)
+		if(INSTALL_MINGW_DEPENDENCIES)
+			install_shared_libs(TARGETS SDL2 DESTINATION bin NO_INSTALL_SYMLINKS REQUIRED)
+		endif()
+	else()
+		message(STATUS "no TARGET SDL2::SDL2, or SDL2, using variables")
+		target_include_directories(FAudio PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
+		target_link_libraries(FAudio PUBLIC ${SDL2_LIBRARIES})
+		if(INSTALL_MINGW_DEPENDENCIES)
+			install_shared_libs(${SDL2_LIBRARIES} DESTINATION bin NO_INSTALL_SYMLINKS)
+		endif()
 	endif()
 endif()
 
@@ -390,7 +398,7 @@
 	)
 	# Install runtime dependencies
 	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(bin -lwinpthread-1 -lwinpthread -lSDL2 -liconv)
+		install_shared_libs(-lwinpthread-1 -lwinpthread -liconv DESTINATION bin NO_INSTALL_SYMLINKS)
 	endif()
 endif()
 
@@ -411,22 +419,3 @@
 install(
 	TARGETS ${PROJECT_NAME}
 	EXPORT ${PROJECT_NAME}-targets
-	INCLUDES DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
-	RUNTIME DESTINATION ${FAudio_INSTALL_BINDIR}
-	LIBRARY DESTINATION ${FAudio_INSTALL_LIBDIR}
-	ARCHIVE DESTINATION ${FAudio_INSTALL_LIBDIR}
-)
-
-# Generate cmake-config file, install CMake files
-include(CMakePackageConfigHelpers)
-configure_package_config_file(
-	cmake/config.cmake.in
-	${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}-config.cmake
-	INSTALL_DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
-)
-install(
-	FILES ${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}-config.cmake
-	DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
-)
-install(
-	EXPORT ${PROJECT_NAME}-targets

=== debian/changelog ===
faudio (19.12-1) unstable; urgency=medium

  * Fix debian/watch.
  * Drop obsolete lintian override 'shlib-calls-exit'.
  * Add README.source.
  * Add Vcs-* fields for new salsa.d.o git repository.
  * Refresh patches.

 -- Jens Reyer <jre.winesim@gmail.com>  Sun, 08 Dec 2019 17:00:40 +0100

faudio (19.11-1) unstable; urgency=medium

  * Update to debhelper 12.
  * Update standards version to 4.4.0.
  * Include Jens Reyer as an uploader.
  * New upstream release (closes: #940203).

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 09 Nov 2019 02:47:48 +0000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,19 @@
 Source: faudio
 Section: libs
 Priority: optional
-Uploaders: Michael Gilbert <mgilbert@debian.org>
+Uploaders:
+ Jens Reyer <jre.winesim@gmail.com>,
+ Michael Gilbert <mgilbert@debian.org>,
 Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
+Vcs-Git: https://salsa.debian.org/wine-team/faudio.git
+Vcs-Browser: https://salsa.debian.org/wine-team/faudio
 Build-Depends:
  cmake,
  libstb-dev,
  libsdl2-dev,
  libavformat-dev,
- debhelper (>= 11),
-Standards-Version: 4.4.0
+ debhelper-compat (= 12),
+Standards-Version: 4.4.1
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

## faudio 20.04

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,8 @@
 option(XNASONG "Build with XNA_Song.c" ON)
 option(LOG_ASSERTIONS "Bind FAudio_assert to log, instead of platform's assert" OFF)
 option(FORCE_ENABLE_DEBUGCONFIGURATION "Enable DebugConfiguration in all build types" OFF)
+option(DUMP_VOICES "Dump voices to RIFF WAVE files" OFF)
+option(BUILD_SHARED_LIBS "Build shared library" ON)
 if(WIN32)
 option(INSTALL_MINGW_DEPENDENCIES "Add dependent libraries to MinGW install target" OFF)
 endif()
@@ -27,8 +29,8 @@
 
 # Version
 SET(LIB_MAJOR_VERSION "0")
-SET(LIB_MINOR_VERSION "19")
-SET(LIB_REVISION "12")
+SET(LIB_MINOR_VERSION "20")
+SET(LIB_REVISION "04")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type
@@ -50,7 +52,8 @@
 
 # Platform Flags
 if(APPLE)
-	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.7)
+	set(CMAKE_MACOSX_RPATH ON)
+	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9)
 elseif(WIN32)
 	# "FAudio.dll", not "libFAudio.dll"
 	set(CMAKE_SHARED_LIBRARY_PREFIX "")
@@ -62,7 +65,7 @@
 endif()
 
 # Source lists
-add_library(FAudio SHARED
+add_library(FAudio
 	# Public Headers
 	include/F3DAudio.h
 	include/FACT3D.h
@@ -155,6 +158,11 @@
 	endif()
 endif(FFMPEG)
 
+# Dump source voices to RIFF WAVE files
+if(DUMP_VOICES)
+	target_compile_definitions(FAudio PRIVATE FAUDIO_DUMP_VOICES)
+endif()
+
 # SDL2 Dependency
 if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
 	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
@@ -219,6 +227,8 @@
 	target_link_libraries(testparse PRIVATE FAudio)
 	add_executable(testxwma utils/testxwma/testxwma.cpp)
 	target_link_libraries(testxwma PRIVATE FAudio)
+	add_executable(showriffheader utils/showriffheader/showriffheader.cpp)
+	target_link_libraries(showriffheader PRIVATE FAudio)
 
 	# These tools use uicommon, but NOT wavs
 	add_executable(facttool utils/facttool/facttool.cpp)
@@ -398,24 +408,3 @@
 	)
 	# Install runtime dependencies
 	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(-lwinpthread-1 -lwinpthread -liconv DESTINATION bin NO_INSTALL_SYMLINKS)
-	endif()
-endif()
-
-# tests/ Folder
-if(BUILD_TESTS)
-	add_executable(faudio_tests tests/xaudio2.c)
-	target_link_libraries(faudio_tests PRIVATE FAudio)
-endif()
-
-# Installation
-
-# Public Headers...
-install(
-	DIRECTORY include/
-	DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
-)
-# Libraries...
-install(
-	TARGETS ${PROJECT_NAME}
-	EXPORT ${PROJECT_NAME}-targets

=== debian/changelog ===
faudio (20.04-2mx19+1) mx; urgency=medium

  * Rebuild for MX-19.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Tue, 14 Jul 2020 07:51:33 -0700

faudio (20.04-2) unstable; urgency=medium

  * Eliminate cmake build percent output.

 -- Michael Gilbert <mgilbert@debian.org>  Sat, 04 Apr 2020 15:11:27 +0000

faudio (20.04-1) unstable; urgency=medium

  * New upstream release (closes: #955500).
  * Exclude cmake files from the binary packages.
  * Detect files missing from the binary packages.
  * Update standards version to 4.5.0 (no changes required).

 -- Michael Gilbert <mgilbert@debian.org>  Fri, 03 Apr 2020 01:46:34 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Uploaders:
  Jens Reyer <jre.winesim@gmail.com>,
  Michael Gilbert <mgilbert@debian.org>,
-Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
+Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
+XSBC-Original-Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
 Vcs-Git: https://salsa.debian.org/wine-team/faudio.git
 Vcs-Browser: https://salsa.debian.org/wine-team/faudio
 Build-Depends:
@@ -13,7 +14,7 @@
  libsdl2-dev,
  libavformat-dev,
  debhelper-compat (= 12),
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

=== debian/rules ===
--- 
+++ 
@@ -13,4 +13,12 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- --no-warn-unused-cli -DFFMPEG=ON -DBUILD_TESTS=ON
+	dh_auto_configure -- --no-warn-unused-cli -DFFMPEG=ON -DBUILD_TESTS=ON -DCMAKE_RULE_MESSAGES=OFF
+
+override_dh_missing:
+	dh_missing --fail-missing
+
+	
+override_dh_strip:
+	dh_strip -a --no-automatic-dbgsym
+

## faudio 21.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
 # CMake Project for FAudio
 # Written by @NeroBurner
 cmake_minimum_required(VERSION 2.8.12)
-project(FAudio)
+project(FAudio C)
 
 # Options
-option(FFMPEG "Enable FFmpeg support (WMA, XMA)" OFF)
+option(GSTREAMER "Enable GStreamer support (WMA, XMA)" OFF)
 option(BUILD_UTILS "Build utils/ folder" OFF)
 option(BUILD_TESTS "Build tests/ folder for unit tests to be executed on the host against FAudio" OFF)
 if(WIN32)
@@ -29,8 +29,8 @@
 
 # Version
 SET(LIB_MAJOR_VERSION "0")
-SET(LIB_MINOR_VERSION "20")
-SET(LIB_REVISION "04")
+SET(LIB_MINOR_VERSION "21")
+SET(LIB_REVISION "02")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type
@@ -100,7 +100,7 @@
 	src/FAudio_platform_sdl2.c
 	# Optional source files
 	src/XNA_Song.c
-	src/FAudio_ffmpeg.c
+	src/FAudio_gstreamer.c
 )
 
 # Only disable DebugConfiguration in release builds
@@ -135,28 +135,29 @@
 	target_compile_definitions(FAudio PRIVATE DISABLE_XNASONG)
 endif()
 
-# FFmpeg Support
-if(FFMPEG)
+# GStreamer Support
+if(GSTREAMER)
 	# Add the extra definition...
-	target_compile_definitions(FAudio PRIVATE HAVE_FFMPEG=1)
-
-	# Find FFmpeg...
-	find_package(FFmpeg COMPONENTS
-		avcodec
-		avutil # dep of avcodec
-		swresample # dep of avcodec
-		REQUIRED
-	)
-
-	# Include/Link FFmpeg...
-	target_include_directories(FAudio PRIVATE ${FFmpeg_INCLUDE_DIRS})
-	target_link_libraries(FAudio PRIVATE ${FFmpeg_LIBRARIES})
-
-	# Install FFmpeg for MinGW target
-	if(INSTALL_MINGW_DEPENDENCIES)
-		install_shared_libs(FILES ${FFmpeg_LIBRARIES} DESTINATION bin NO_INSTALL_SYMLINKS REQUIRED)
-	endif()
-endif(FFMPEG)
+	target_compile_definitions(FAudio PRIVATE HAVE_GSTREAMER=1)
+
+	# Find GStreamer
+	find_package(PkgConfig)
+	pkg_check_modules(GST REQUIRED gstreamer-1.0>=1.9.2)
+	pkg_check_modules(GSTAUDIO REQUIRED gstreamer-audio-1.0>=1.9.2)
+	pkg_check_modules(GSTAPP REQUIRED gstreamer-app-1.0>=1.9.2)
+
+	# Include/Link GStreamer...
+	target_include_directories(FAudio PRIVATE
+		${GST_INCLUDE_DIRS}
+		${GSTAUDIO_INCLUDE_DIRS}
+		${GSTAPP_INCLUDE_DIRS}
+	)
+	target_link_libraries(FAudio PRIVATE
+            ${GST_LDFLAGS}
+            ${GSTAUDIO_LDFLAGS}
+            ${GSTAPP_LDFLAGS}
+        )
+endif(GSTREAMER)
 
 # Dump source voices to RIFF WAVE files
 if(DUMP_VOICES)
@@ -198,6 +199,8 @@
 
 # utils/ Folder
 if(BUILD_UTILS)
+	enable_language(CXX)
+
 	# Shared ImGui Framework
 	add_library(uicommon STATIC
 		utils/uicommon/FAudioUI_main.cpp
@@ -208,11 +211,12 @@
 		utils/uicommon/imgui.cpp
 		utils/uicommon/imgui_demo.cpp
 		utils/uicommon/imgui_draw.cpp
+		utils/uicommon/imgui_widgets.cpp
 		utils/uicommon/imgui.h
 		utils/uicommon/imgui_internal.h
-		utils/uicommon/stb_rect_pack.h
-		utils/uicommon/stb_textedit.h
-		utils/uicommon/stb_truetype.h
+		utils/uicommon/imstb_rectpack.h
+		utils/uicommon/imstb_textedit.h
+		utils/uicommon/imstb_truetype.h
 	)
 	target_link_libraries(uicommon PUBLIC FAudio)
 
@@ -279,6 +283,8 @@
 
 # cpp/ Folder
 if(BUILD_CPP)
+	enable_language(CXX)
+
 	# XAPOBase, used by XAudio2 and XAPOFX
 	add_library(XAPOBase STATIC
 		cpp/XAPOBase.cpp
@@ -404,7 +410,3 @@
 	)
 	# Add Wine install script to install target
 	install(PROGRAMS cpp/scripts/wine_setup_native
-		DESTINATION ${FAudio_INSTALL_BINDIR}
-	)
-	# Install runtime dependencies
-	if(INSTALL_MINGW_DEPENDENCIES)

=== tests/Makefile ===
# Build win32 executable to verify unit tests pass when run
# against XAudio2 on Windows.

WINEROOT = /usr/include/wine

CROSSCC = x86_64-w64-mingw32-gcc

CFLAGS += -g -Wall

all: faudio_tests.exe

faudio_tests.exe: xaudio2.c
	$(CROSSCC) $(CFLAGS) -Wall -I$(WINEROOT)/windows/ -o $@ $< -lole32

=== debian/changelog ===
faudio (21.02-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.5.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Tue, 02 Feb 2021 20:20:36 +0100

faudio (21.01-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 02 Jan 2021 14:54:17 +0100

faudio (20.12-1) unstable; urgency=medium

  * New upstream release.
  * Update the instructions for importing new versions.

 -- Stephen Kitt <skitt@debian.org>  Thu, 03 Dec 2020 15:09:37 +0100

faudio (20.11-1) unstable; urgency=medium

  * New upstream release, switching from ffmpeg to gstreamer.
  * Add myself to Uploaders.
  * Switch to debhelper compatibility level 13.

 -- Stephen Kitt <skitt@debian.org>  Thu, 05 Nov 2020 21:13:27 +0100

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,18 @@
 Uploaders:
  Jens Reyer <jre.winesim@gmail.com>,
  Michael Gilbert <mgilbert@debian.org>,
-Maintainer: Mike Purtell <mmikeinsantarosa@mxlinux.org>
-XSBC-Original-Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
+ Stephen Kitt <skitt@debian.org>,
+Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
 Vcs-Git: https://salsa.debian.org/wine-team/faudio.git
 Vcs-Browser: https://salsa.debian.org/wine-team/faudio
 Build-Depends:
  cmake,
  libstb-dev,
  libsdl2-dev,
- libavformat-dev,
- debhelper-compat (= 12),
-Standards-Version: 4.5.0
+ libgstreamer1.0-dev,
+ libgstreamer-plugins-base1.0-dev,
+ debhelper-compat (= 13),
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/faudio-$1\.tar\.gz/ \
  https://github.com/FNA-XNA/FAudio/tags .*/v?(\d\S+)\.tar\.gz

## faudio 22.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,10 @@
 project(FAudio C)
 
 # Options
-option(GSTREAMER "Enable GStreamer support (WMA, XMA)" OFF)
 option(BUILD_UTILS "Build utils/ folder" OFF)
 option(BUILD_TESTS "Build tests/ folder for unit tests to be executed on the host against FAudio" OFF)
 if(WIN32)
-option(BUILD_CPP "Build cpp/ folder (COM wrapper for XAudio2)" OFF)
+option(PLATFORM_WIN32 "Enable native Win32 platform instead of SDL2" OFF)
 endif()
 option(XNASONG "Build with XNA_Song.c" ON)
 option(LOG_ASSERTIONS "Bind FAudio_assert to log, instead of platform's assert" OFF)
@@ -29,7 +28,7 @@
 
 # Version
 SET(LIB_MAJOR_VERSION "0")
-SET(LIB_MINOR_VERSION "21")
+SET(LIB_MINOR_VERSION "22")
 SET(LIB_REVISION "02")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
@@ -98,10 +97,20 @@
 	src/FAudio_internal_simd.c
 	src/FAudio_operationset.c
 	src/FAudio_platform_sdl2.c
+	src/FAudio_platform_win32.c
 	# Optional source files
 	src/XNA_Song.c
-	src/FAudio_gstreamer.c
-)
+)
+
+if(PLATFORM_WIN32)
+	target_link_libraries(FAudio PRIVATE -ldxguid -luuid -lwinmm -lole32 -ladvapi32 -luser32 -lmfplat -lmfreadwrite -lmfuuid -lpropsys)
+	target_compile_definitions(FAudio PUBLIC FAUDIO_WIN32_PLATFORM)
+	target_compile_definitions(FAudio PRIVATE HAVE_WMADEC=1)
+	set(PLATFORM_CFLAGS "-DFAUDIO_WIN32_PLATFORM")
+	set(XNASONG OFF)
+else()
+	set(PLATFORM_CFLAGS)
+endif()
 
 # Only disable DebugConfiguration in release builds
 if(NOT FORCE_ENABLE_DEBUGCONFIGURATION)
@@ -135,37 +144,15 @@
 	target_compile_definitions(FAudio PRIVATE DISABLE_XNASONG)
 endif()
 
-# GStreamer Support
-if(GSTREAMER)
-	# Add the extra definition...
-	target_compile_definitions(FAudio PRIVATE HAVE_GSTREAMER=1)
-
-	# Find GStreamer
-	find_package(PkgConfig)
-	pkg_check_modules(GST REQUIRED gstreamer-1.0>=1.9.2)
-	pkg_check_modules(GSTAUDIO REQUIRED gstreamer-audio-1.0>=1.9.2)
-	pkg_check_modules(GSTAPP REQUIRED gstreamer-app-1.0>=1.9.2)
-
-	# Include/Link GStreamer...
-	target_include_directories(FAudio PRIVATE
-		${GST_INCLUDE_DIRS}
-		${GSTAUDIO_INCLUDE_DIRS}
-		${GSTAPP_INCLUDE_DIRS}
-	)
-	target_link_libraries(FAudio PRIVATE
-            ${GST_LDFLAGS}
-            ${GSTAUDIO_LDFLAGS}
-            ${GSTAPP_LDFLAGS}
-        )
-endif(GSTREAMER)
-
 # Dump source voices to RIFF WAVE files
 if(DUMP_VOICES)
 	target_compile_definitions(FAudio PRIVATE FAUDIO_DUMP_VOICES)
 endif()
 
 # SDL2 Dependency
-if (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
+if (PLATFORM_WIN32)
+	message(STATUS "not using SDL2")
+elseif (DEFINED SDL2_INCLUDE_DIRS AND DEFINED SDL2_LIBRARIES)
 	message(STATUS "using pre-defined SDL2 variables SDL2_INCLUDE_DIRS and SDL2_LIBRARIES")
 	target_include_directories(FAudio PUBLIC "$<BUILD_INTERFACE:${SDL2_INCLUDE_DIRS}>")
 	target_link_libraries(FAudio PUBLIC ${SDL2_LIBRARIES})
@@ -204,7 +191,6 @@
 	# Shared ImGui Framework
 	add_library(uicommon STATIC
 		utils/uicommon/FAudioUI_main.cpp
-		utils/uicommon/FAudioUI_ui.cpp
 		utils/uicommon/glfuncs.h
 		utils/uicommon/glmacros.h
 		utils/uicommon/imconfig.h
@@ -281,132 +267,56 @@
 	set(FAudio_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
 endif()
 
-# cpp/ Folder
-if(BUILD_CPP)
-	enable_language(CXX)
-
-	# XAPOBase, used by XAudio2 and XAPOFX
-	add_library(XAPOBase STATIC
-		cpp/XAPOBase.cpp
-	)
-	target_compile_definitions(XAPOBase PRIVATE
-		FAUDIOCPP_EXPORTS
-		_WIN32_WINNT=0x0600
-	)
-	target_link_libraries(XAPOBase PRIVATE FAudio)
-	if(MINGW)
-		target_link_libraries(XAPOBase PRIVATE
-			"-Wl,--enable-stdcall-fixup"
-		)
-		# Enable various compiler warnings
-		target_link_libraries(XAPOBase PRIVATE
-			-Wall -pedantic
-			-Wsign-compare
-			-Wshadow
-		)
-	endif()
-
-	# We're about to make a whole bunch of DLLs...
-	set(FAudio_CPP_libs "")
-
-	# XAudio2 2.0-2.7
-	foreach(lib_version RANGE 0 7)
-		set(faudio_cpp_target "xaudio2_${lib_version}")
-		add_library(${faudio_cpp_target} SHARED
-			cpp/com_utils.cpp
-			cpp/xaudio2.cpp
-			cpp/XAudio2fx.cpp
-			cpp/win_registry.cpp
-		)
-		target_compile_definitions(${faudio_cpp_target} PRIVATE
-			"XAUDIO2_VERSION=${lib_version}"
-		)
-		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase)
-		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
-	endforeach()
-
-	# XAudio2 2.8-2.9
-	foreach(lib_version RANGE 8 9)
-		set(faudio_cpp_target "xaudio2_${lib_version}")
-		add_library(${faudio_cpp_target} SHARED
-			cpp/com_utils.cpp
-			cpp/xaudio2.cpp
-			cpp/XAudio2fx.cpp
-			cpp/win_device.cpp
-			cpp/X3DAudio.cpp
-			cpp/XAPOFX.cpp
-		)
-		target_compile_definitions(${faudio_cpp_target} PRIVATE
-			"XAUDIO2_VERSION=${lib_version}"
-			UNICODE
-		)
-		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase setupapi)
-		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
-	endforeach()
-
-	# X3DAudio 1.3-1.7
-	foreach(lib_version RANGE 3 7)
-		set(faudio_cpp_target "x3daudio1_${lib_version}")
-		add_library(${faudio_cpp_target} SHARED cpp/X3DAudio.cpp)
-		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
-	endforeach()
-
-	# XAPOFX 1.1-1.5
-	foreach(lib_version RANGE 1 5)
-		set(faudio_cpp_target "xapofx1_${lib_version}")
-		add_library(${faudio_cpp_target} SHARED
-			cpp/com_utils_xapofx.cpp
-			cpp/XAPOFX.cpp
-		)
-		target_link_libraries(${faudio_cpp_target} PRIVATE XAPOBase)
-		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
-	endforeach()
-
-	# XACTEngine3 3.0-3.7
-	foreach(lib_version RANGE 0 7)
-		set(faudio_cpp_target "xactengine3_${lib_version}")
-		add_library(${faudio_cpp_target} SHARED
-			cpp/com_utils_xact.cpp
-			cpp/xact3.cpp
-			cpp/win_registry.cpp
-		)
-		target_compile_definitions(${faudio_cpp_target} PRIVATE
-			"XACT3_VERSION=${lib_version}"
-		)
-		list(APPEND FAudio_CPP_libs ${faudio_cpp_target})
-	endforeach()
-
-	# Common Libraries/Definitions
-	foreach(faudio_cpp_target ${FAudio_CPP_libs})
-		target_link_libraries(${faudio_cpp_target} PRIVATE
-			ole32
-			FAudio
-		)
-		target_compile_definitions(${faudio_cpp_target} PRIVATE
-			FAUDIOCPP_EXPORTS
-			_WIN32_WINNT=0x0600
-		)
-
-		# MinGW builds should statically link libgcc/libstdc++
-		if(MINGW)
-			target_link_libraries(${faudio_cpp_target} PRIVATE
-				"-Wl,--enable-stdcall-fixup"
-				"-static-libgcc -static-libstdc++"
-			)
-			# Enable various compiler warnings
-			target_link_libraries(${faudio_cpp_target} PRIVATE
-				-Wall -pedantic
-				-Wsign-compare
-				-Wshadow
-			)
-		endif()
-	endforeach()
-
-	# Add libraries to install target
-	install(TARGETS ${FAudio_CPP_libs}
-		RUNTIME DESTINATION ${FAudio_INSTALL_BINDIR}
-		LIBRARY DESTINATION ${FAudio_INSTALL_LIBDIR}
-		ARCHIVE DESTINATION ${FAudio_INSTALL_LIBDIR}
-	)
-	# Add Wine install script to install target
-	install(PROGRAMS cpp/scripts/wine_setup_native
+# tests/ Folder
+if(BUILD_TESTS)
+	add_executable(faudio_tests tests/xaudio2.c)
+	target_link_libraries(faudio_tests PRIVATE FAudio)
+endif()
+
+# Installation
+
+# Public Headers...
+install(
+	DIRECTORY include/
+	DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
+)
+# Libraries...
+install(
+	TARGETS ${PROJECT_NAME}
+	EXPORT ${PROJECT_NAME}-targets
+	INCLUDES DESTINATION ${FAudio_INSTALL_INCLUDEDIR}
+	RUNTIME DESTINATION ${FAudio_INSTALL_BINDIR}
+	LIBRARY DESTINATION ${FAudio_INSTALL_LIBDIR}
+	ARCHIVE DESTINATION ${FAudio_INSTALL_LIBDIR}
+)
+
+# Generate a pkgconfig file
+include(cmake/JoinPaths.cmake)
+join_paths(FAUDIO_PKGCONF_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(FAUDIO_PKGCONF_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
+configure_file(
+	"${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}.pc.in"
+	${PROJECT_BINARY_DIR}/generated/${PROJECT_NAME}.pc
+	@ONLY
+)
+install(
+	FILES ${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}.pc
+	DESTINATION ${FAudio_INSTALL_LIBDIR}/pkgconfig
+)
+
+# Generate cmake-config file, install CMake files
+include(CMakePackageConfigHelpers)
+configure_package_config_file(
+	cmake/config.cmake.in
+	${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}Config.cmake
+	INSTALL_DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
+)
+install(
+	FILES ${CMAKE_CURRENT_BINARY_DIR}/generated/${PROJECT_NAME}Config.cmake
+	DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
+)
+install(
+	EXPORT ${PROJECT_NAME}-targets
+	NAMESPACE ${PROJECT_NAME}::
+	DESTINATION ${FAudio_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
+)

=== debian/changelog ===
faudio (22.02-1) unstable; urgency=medium

  * New upstream release, dropping gstreamer support.

 -- Stephen Kitt <skitt@debian.org>  Tue, 01 Feb 2022 17:39:01 +0100

faudio (22.01-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Jan 2022 18:00:30 +0100

faudio (21.12-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 04 Dec 2021 09:46:38 +0100

faudio (21.11-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 01 Nov 2021 17:28:33 +0100

faudio (21.10-1) unstable; urgency=medium

  * New upstream release.
  * Recommend gstreamer1.0-libav. Closes: #986440.

 -- Stephen Kitt <skitt@debian.org>  Tue, 26 Oct 2021 21:04:30 +0200

faudio (21.09-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 05 Sep 2021 17:35:39 +0200

faudio (21.07-1) experimental; urgency=medium

  [ Jens Reyer ]
  * Remove myself from Uploaders.

  [ Stephen Kitt ]
  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 11 Jul 2021 20:00:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: libs
 Priority: optional
 Uploaders:
- Jens Reyer <jre.winesim@gmail.com>,
  Michael Gilbert <mgilbert@debian.org>,
  Stephen Kitt <skitt@debian.org>,
 Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
@@ -12,10 +11,8 @@
  cmake,
  libstb-dev,
  libsdl2-dev,
- libgstreamer1.0-dev,
- libgstreamer-plugins-base1.0-dev,
  debhelper-compat (= 13),
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

## faudio 22.08

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 # Version
 SET(LIB_MAJOR_VERSION "0")
 SET(LIB_MINOR_VERSION "22")
-SET(LIB_REVISION "02")
+SET(LIB_REVISION "08")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type
@@ -191,8 +191,6 @@
 	# Shared ImGui Framework
 	add_library(uicommon STATIC
 		utils/uicommon/FAudioUI_main.cpp
-		utils/uicommon/glfuncs.h
-		utils/uicommon/glmacros.h
 		utils/uicommon/imconfig.h
 		utils/uicommon/imgui.cpp
 		utils/uicommon/imgui_demo.cpp

=== debian/changelog ===
faudio (22.08-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 10 Aug 2022 21:22:44 +0200

faudio (22.07-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Fri, 01 Jul 2022 18:44:55 +0200

faudio (22.06-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 18 Jun 2022 13:42:54 +0200

faudio (22.05-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 07 May 2022 23:08:01 +0200

faudio (22.04-1) unstable; urgency=medium

  * New upstream release.
  * Document Debian patches that aren’t relevant for upstream.
  * Install cmake files in the -dev package.

 -- Stephen Kitt <skitt@debian.org>  Sun, 03 Apr 2022 19:23:23 +0200

faudio (22.03-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 05 Mar 2022 15:21:05 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libstb-dev,
  libsdl2-dev,
  debhelper-compat (= 13),
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

## faudio 22.09.01+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 # Version
 SET(LIB_MAJOR_VERSION "0")
 SET(LIB_MINOR_VERSION "22")
-SET(LIB_REVISION "08")
+SET(LIB_REVISION "09")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type

=== debian/changelog ===
faudio (22.09.01+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 04 Sep 2022 18:33:47 +0200

faudio (22.09+dfsg-1) unstable; urgency=medium

  * Add a +dfsg suffix to signal the fact that we repack the source
    code.
  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Thu, 01 Sep 2022 17:37:24 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Build-Depends:
  cmake,
  libstb-dev,
- libsdl2-dev,
+ libsdl2-dev (>= 2.24.0~),
  debhelper-compat (= 13),
 Standards-Version: 4.6.1
 Rules-Requires-Root: no

## faudio 23.02+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,8 @@
 
 # Version
 SET(LIB_MAJOR_VERSION "0")
-SET(LIB_MINOR_VERSION "22")
-SET(LIB_REVISION "09")
+SET(LIB_MINOR_VERSION "23")
+SET(LIB_REVISION "02")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type

=== debian/changelog ===
faudio (23.02+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 01 Feb 2023 21:25:22 +0100

faudio (23.01+dfsg-1) unstable; urgency=medium

  * Update file exclusions.
  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 01 Jan 2023 21:31:52 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  libstb-dev,
  libsdl2-dev (>= 2.24.0~),
  debhelper-compat (= 13),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/FNA-XNA/FAudio

## faudio 23.07+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 # Version
 SET(LIB_MAJOR_VERSION "0")
 SET(LIB_MINOR_VERSION "23")
-SET(LIB_REVISION "02")
+SET(LIB_REVISION "07")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type
@@ -79,6 +79,7 @@
 	src/FAudio_internal.h
 	src/stb.h
 	src/stb_vorbis.h
+	src/qoa_decoder.h
 	# Source Files
 	src/F3DAudio.c
 	src/FACT3D.c
@@ -249,6 +250,10 @@
 		utils/testvolumemeter/testvolumemeter.cpp
 	)
 	target_link_libraries(testvolumemeter PRIVATE uicommon wavs)
+	add_executable(voicepool
+		utils/voicepool/voicepool.cpp
+	)
+	target_link_libraries(voicepool PRIVATE uicommon wavs)
 endif()
 
 # define install directories
@@ -268,6 +273,7 @@
 # tests/ Folder
 if(BUILD_TESTS)
 	add_executable(faudio_tests tests/xaudio2.c)
+	target_compile_definitions(faudio_tests PRIVATE _DEFAULT_SOURCE _BSD_SOURCE)
 	target_link_libraries(faudio_tests PRIVATE FAudio)
 endif()

=== debian/changelog ===
faudio (23.07+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 08 Jul 2023 17:43:00 +0200

faudio (23.06+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sat, 17 Jun 2023 20:15:20 +0200

## faudio 24.02%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,8 +28,8 @@
 
 # Version
 SET(LIB_MAJOR_VERSION "0")
-SET(LIB_MINOR_VERSION "23")
-SET(LIB_REVISION "07")
+SET(LIB_MINOR_VERSION "24")
+SET(LIB_REVISION "02")
 SET(LIB_VERSION "${LIB_MAJOR_VERSION}.${LIB_MINOR_VERSION}.${LIB_REVISION}")
 
 # Build Type

## faudio 24.02+dfsg

=== debian/changelog ===
faudio (24.02+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:13:43 +0000

faudio (24.02+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libstb0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Mar 2024 00:54:39 +0000

faudio (24.02+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Adjust excluded files for changes in 24.01 and 24.02.

 -- Stephen Kitt <skitt@debian.org>  Sat, 17 Feb 2024 16:09:59 +0100

faudio (23.11+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 01 Nov 2023 16:04:15 +0100

faudio (23.08+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Fri, 18 Aug 2023 17:04:24 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Uploaders:
  Michael Gilbert <mgilbert@debian.org>,
  Stephen Kitt <skitt@debian.org>,
-Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Wine Team <debian-wine@lists.debian.org>
 Vcs-Git: https://salsa.debian.org/wine-team/faudio.git
 Vcs-Browser: https://salsa.debian.org/wine-team/faudio
 Build-Depends:

=== debian/rules ===
--- 
+++ 
@@ -13,12 +13,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- --no-warn-unused-cli -DFFMPEG=ON -DBUILD_TESTS=ON -DCMAKE_RULE_MESSAGES=OFF
+	dh_auto_configure -- --no-warn-unused-cli -DGSTREAMER=ON -DBUILD_TESTS=ON -DCMAKE_RULE_MESSAGES=OFF
 
 override_dh_missing:
 	dh_missing --fail-missing
-
-	
-override_dh_strip:
-	dh_strip -a --no-automatic-dbgsym
-
